VERSION 5.00
Begin VB.UserControl SoftButton 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1635
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3285
   HitBehavior     =   0  'None
   ScaleHeight     =   1635
   ScaleWidth      =   3285
   ToolboxBitmap   =   "SoftButton.ctx":0000
   Begin VB.Timer tmrMouse 
      Enabled         =   0   'False
      Left            =   480
      Top             =   480
   End
End
Attribute VB_Name = "SoftButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'
' UserControl SoftButton (SoftButton.ctl)
' -----------------------------------------
'
' Purpose: Used to draw and hold a soft
' button's properties.
'


'
' Public Enums.
'

Public Enum AppearanceStyle
    [Flat]
    [Soft]
    [3D]
End Enum

Public Enum ButtonStyle
    [Standard]
    [CheckBox]
End Enum

'
' Private Variables.
'


' The Button's Caption.
Private sCaption As String
' Appearance of the Button (Flat, Soft or 3D).
Private udtAppearance As AppearanceStyle
' Appearance of the Button (Flat, Soft or 3D)
' when the mouse is over the button.
Private udtMouseOverAppearance As AppearanceStyle
' Appearance of the Button (Flat, Soft or 3D)
' when the button is pressed down.
Private udtButtonDownAppearance As AppearanceStyle
' Visible Property.
Private bVisible As Boolean
' The Picture Property.
Private clsPicture As Picture
' The Picture when the Button is Down.
Private clsDownPicture As Picture
' Is the Button being pressed down?
Private bButtonDown As Boolean
' Does the Button has the Focus?
Private bFocused As Boolean
' Is the Mouse Over the Button.
Private bMouseOver As Boolean
' Should a Dot Square Shape be drawn
' when the button gets the focus?
Private bDrawFocus As Boolean
' The Button's Style - Standard or Checkbox.
Private udtStyle As ButtonStyle
' Is the Button Checked? (Only In Checkbox Style).
Private bChecked As Boolean


'
' Public Events.
'


'Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event Click()
Public Event DblClick()

Public Event MouseOut()

Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)

'Public Event GotFocus()
'Public Event LostFocus()

'
' Public Properties.
'

'
' Style Property.
'


Public Property Get Style() As ButtonStyle
    Style = udtStyle
End Property

Public Property Let Style(ByVal vData As ButtonStyle)
    udtStyle = vData
    
    UserControl.PropertyChanged "Style"
    Call RedrawButton
End Property


'
' ForeColor Property.
'

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal vData As OLE_COLOR)
    UserControl.ForeColor = vData
    
    UserControl.PropertyChanged "Forecolor"
    Call RedrawButton
End Property


'
' Enabled Property.
'

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal vData As Boolean)
    UserControl.Enabled = vData
    
    UserControl.PropertyChanged "Enabled"
    Call RedrawButton
End Property



'
' Font Property.
'


Public Property Get Font() As Font
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Appearance"
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal vData As Font)
    Set UserControl.Font = vData
    
    UserControl.PropertyChanged "Font"
    Call RedrawButton
End Property


Public Property Let Font(ByVal vData As Font)
    Set UserControl.Font = vData
    
    UserControl.PropertyChanged "Font"
    Call RedrawButton
End Property

'
' Picture Property.
'


Public Property Get Picture() As Picture
    Set Picture = clsPicture
End Property

Public Property Set Picture(ByVal vData As Picture)
    Set clsPicture = vData
    
    UserControl.PropertyChanged "Picture"
    Call RedrawButton
End Property


'
' DownPicture Property.
'


Public Property Get DownPicture() As Picture
    Set DownPicture = clsDownPicture
End Property

Public Property Set DownPicture(ByVal vData As Picture)
    Set clsDownPicture = vData
    
    UserControl.PropertyChanged "DownPicture"
    Call RedrawButton
End Property



'
' Visible Property.
'


Public Property Get Visible() As Boolean
    Visible = UserControl.Visible
End Property

Public Property Let Visible(ByVal vData As Boolean)
    UserControl.Visible = vData

    UserControl.PropertyChanged "Visible"
    Call RedrawButton
End Property


'
' Appearance Property.
'


Public Property Get Appearance() As AppearanceStyle
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Appearance = udtAppearance
End Property

Public Property Let Appearance(ByVal vData As AppearanceStyle)
    udtAppearance = vData
    
    UserControl.PropertyChanged "Appearance"
    Call RedrawButton
End Property


'
' MouseOverAppearance Property.
'


Public Property Get MouseOverAppearance() As AppearanceStyle
    MouseOverAppearance = udtMouseOverAppearance
End Property

Public Property Let MouseOverAppearance(ByVal vData As AppearanceStyle)
    udtMouseOverAppearance = vData

    UserControl.PropertyChanged "MouseOverAppearance"
    Call RedrawButton
End Property


'
' ButtonDownAppearance Property.
'


Public Property Get ButtonDownAppearance() As AppearanceStyle
    ButtonDownAppearance = udtButtonDownAppearance
End Property

Public Property Let ButtonDownAppearance(ByVal vData As AppearanceStyle)
    udtButtonDownAppearance = vData
    
    UserControl.PropertyChanged "ButtonDownAppearance"
    Call RedrawButton
End Property


'
' Backcolor Property.
'


Public Property Get Backcolor() As OLE_COLOR
    Backcolor = UserControl.Backcolor
End Property

Public Property Let Backcolor(ByVal vData As OLE_COLOR)
    UserControl.Backcolor = vData
    
    UserControl.PropertyChanged "Backcolor"
    Call RedrawButton
End Property


'
' Height Property.
'


Public Property Get Height() As Integer
    Height = UserControl.Height
End Property

Public Property Let Height(ByVal vData As Integer)
    UserControl.Height = vData

    UserControl.PropertyChanged "Height"
    Call RedrawButton
End Property


'
' Width Property.
'


Public Property Get Width() As Integer
    Width = UserControl.Width
End Property

Public Property Let Width(ByVal vData As Integer)
    UserControl.Width = vData

    UserControl.PropertyChanged "Width"
    Call RedrawButton
End Property


'
' Top Property.
'


Public Property Get Top() As Integer
    Top = UserControl.Top
End Property

Public Property Let Top(ByVal vData As Integer)
    UserControl.Top = vData

    UserControl.PropertyChanged "Top"
    Call RedrawButton
End Property


'
' Left Top.
'

Public Property Get Left() As Integer
    Left = UserControl.Left
End Property

Public Property Let Left(ByVal vData As Integer)
    UserControl.Left = vData

    UserControl.PropertyChanged "Left"
    Call RedrawButton
End Property


'
' Caption Property.
'


Public Property Get Caption() As String
    Caption = sCaption
End Property

Public Property Let Caption(ByVal vData As String)
    sCaption = vData
    
    UserControl.PropertyChanged "Caption"
    Call RedrawButton
End Property


'
' DrawFocus Property.
'


Public Property Get DrawFocus() As Boolean
    DrawFocus = bDrawFocus
End Property

Public Property Let DrawFocus(ByVal vData As Boolean)
    bDrawFocus = vData
    
    UserControl.PropertyChanged "DrawFocus"
    Call RedrawButton
End Property

'
' Checked Property.
'


Public Property Get Checked() As Boolean
    Checked = bChecked
End Property

Public Property Let Checked(ByVal vData As Boolean)
    bChecked = vData
    
    UserControl.PropertyChanged "Checked"
    Call RedrawButton
End Property



'
' Private Subs.
'


'
' Redraws the button.
'
Private Sub RedrawButton()
Const LIGHT_BORDER_COLOR As Long = vbWhite '&HE0E0E0
Const LIGHT_MID_BORDER_COLOR As Long = &HE0E0E0
Const MID_BORDER_COLOR As Long = &H808080
Const DARK_BORDER_COLOR As Long = vbBlack

Dim i As Integer
Dim iAdd As Integer
Dim iPicWidth As Integer, iPicHeight As Integer
Dim lOldForecolor As Long, OldX As Integer, OldY As Integer
Dim clsOldPicture As Picture

Const BACK_DISABLED_COLOR As Long = vbWhite
Const FRONT_DISABLED_COLOR As Long = &H808080

    ' Clear the UserControl first.
    UserControl.Cls
    
    UserControl.DrawWidth = 1
    UserControl.DrawStyle = 0 ' Solid.
    UserControl.DrawMode = 13 ' Copy Pen.
    
    If (udtStyle = CheckBox) And (bChecked = True) Then
        bButtonDown = True
    ElseIf (udtStyle = CheckBox) And (bChecked = False) Then
        bButtonDown = False
    End If
    
    Set clsOldPicture = clsPicture
    If (bButtonDown = True) And (Not (clsDownPicture Is Nothing)) Then
        Set clsPicture = clsDownPicture
    End If
    
    If (clsPicture Is Nothing) Then
        iPicWidth = 0
        iPicHeight = UserControl.TextHeight(sCaption)
    Else
        iPicWidth = clsPicture.Width
        
        If (sCaption <> "") Then
            iPicHeight = UserControl.TextHeight(sCaption) 'clsPicture.scaleheight
        Else
            iPicHeight = clsPicture.Height
        End If
    End If
    
    If (Not (clsPicture Is Nothing)) And (sCaption = "") Then
        UserControl.CurrentX = (UserControl.ScaleWidth - (iPicWidth / 2)) / 2
        UserControl.CurrentY = (UserControl.ScaleHeight - (iPicHeight / 2)) / 2
    ElseIf (Not (clsPicture Is Nothing)) And (sCaption <> "") Then
        UserControl.CurrentX = (UserControl.ScaleWidth / 2 - (UserControl.TextWidth(sCaption) + iPicWidth) / 2) '(UserControl.ScaleWidth - UserControl.TextWidth(sCaption)) / 2 - UserControl.TextWidth(sCaption) / 4 '(UserControl.ScaleWidth / 2) - (UserControl.TextWidth(sCaption) + iPicWidth) / 2
        UserControl.CurrentY = (UserControl.ScaleHeight / 2 - iPicHeight / 2) '(UserControl.ScaleHeight / 2 - iPicHeight)  ' / 2
    ElseIf (clsPicture Is Nothing) And (sCaption <> "") Then
        UserControl.CurrentX = (UserControl.ScaleWidth - UserControl.TextWidth(sCaption)) / 2
        UserControl.CurrentY = (UserControl.ScaleHeight - UserControl.TextHeight(sCaption)) / 2
    End If
    
    If (Not (clsPicture Is Nothing)) And (UserControl.Enabled = False) Then
        ' Draw a Disabled Picture.
    End If
    
    If Not (clsPicture Is Nothing) Then
        ' Print the Picture.
        Call UserControl.PaintPicture(clsPicture, UserControl.CurrentX, UserControl.CurrentY)
        
        'UserControl.CurrentX = UserControl.CurrentX + clsPicture.Width
        UserControl.CurrentX = UserControl.CurrentX + clsPicture.Width
        'UserControl.CurrentY = (UserControl.CurrentY + iPicHeight) / 2
    End If
    
    If (sCaption <> "") Then
    
        If (UserControl.Enabled = True) Then
            ' Draw the Caption.
            UserControl.Print sCaption
        Else
            ' Draw a Disabled Text.
            lOldForecolor = UserControl.ForeColor
            OldX = UserControl.CurrentX
            OldY = UserControl.CurrentY
            
            UserControl.ForeColor = BACK_DISABLED_COLOR
            UserControl.Print sCaption
        
            UserControl.CurrentX = OldX - 15
            UserControl.CurrentY = OldY - 10
            UserControl.ForeColor = FRONT_DISABLED_COLOR
            UserControl.Print sCaption
            
            UserControl.ForeColor = lOldForecolor
        End If
    Else
        ' No Caption.
    End If
    
    ' Draw a Black border if the Button is Focused.
    If (bFocused = False) Or (bDrawFocus = False) Then
        iAdd = 0
    Else
        iAdd = 20
        
        UserControl.Line (1, 1)-(UserControl.ScaleWidth - 10, UserControl.ScaleHeight - 10), DARK_BORDER_COLOR, B
    End If
    
    If ((udtAppearance = Flat) And (bMouseOver = False) And (bButtonDown = False)) Or _
    ((udtMouseOverAppearance = Flat) And (bMouseOver = True) And (bButtonDown = False)) Or _
    ((udtButtonDownAppearance = Flat) And (bButtonDown = True)) Then
        ' Draw no border.
        
    ElseIf ((udtAppearance = Soft) And (bMouseOver = False) And (bButtonDown = False)) Or _
    ((udtMouseOverAppearance = Soft) And (bMouseOver = True) And (bButtonDown = False)) Or _
    ((udtButtonDownAppearance = Soft) And (bButtonDown = True)) Then
        ' Draw a Soft Border.
        
        If (bButtonDown = False) Then
            UserControl.Line (1 + iAdd, 1 + iAdd)-(UserControl.ScaleWidth - 10 - iAdd, 1 + iAdd), LIGHT_BORDER_COLOR
            UserControl.Line (1 + iAdd, 1 + iAdd)-(1 + iAdd, UserControl.ScaleHeight - 10 - iAdd), LIGHT_BORDER_COLOR
            
            UserControl.Line (1 + iAdd, UserControl.ScaleHeight - 10 - iAdd)-(UserControl.ScaleWidth - 1 - iAdd, UserControl.ScaleHeight - 10 - iAdd), DARK_BORDER_COLOR
            UserControl.Line (UserControl.ScaleWidth - 10 - iAdd, 1 + iAdd)-(UserControl.ScaleWidth - 10 - iAdd, UserControl.ScaleHeight - 10 - iAdd), DARK_BORDER_COLOR
        Else
            UserControl.Line (1, 1)-(UserControl.ScaleWidth - 10, 1), DARK_BORDER_COLOR
            UserControl.Line (1, 1)-(1, UserControl.ScaleHeight - 10), DARK_BORDER_COLOR
            
            UserControl.Line (1, UserControl.ScaleHeight - 10)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 10), LIGHT_BORDER_COLOR
            UserControl.Line (UserControl.ScaleWidth - 10, 1)-(UserControl.ScaleWidth - 10, UserControl.ScaleHeight - 10), LIGHT_BORDER_COLOR
        End If
        
    ElseIf ((udtAppearance = [3D]) And (bMouseOver = False) And (bButtonDown = False)) Or _
    ((udtMouseOverAppearance = [3D]) And (bMouseOver = True) And (bButtonDown = False)) Or _
    ((udtButtonDownAppearance = [3D]) And (bButtonDown = True)) Then
        ' Draw a 3D Border.
        
        If (bButtonDown = False) Then
            UserControl.DrawWidth = 1
            UserControl.Line (1 + iAdd, 1 + iAdd)-(UserControl.ScaleWidth - 10 - iAdd, 1 + iAdd), LIGHT_BORDER_COLOR
            UserControl.Line (1 + iAdd, 1 + iAdd)-(1 + iAdd, UserControl.ScaleHeight - 10 - iAdd), LIGHT_BORDER_COLOR
            
            UserControl.DrawWidth = 1
            UserControl.Line (1 + iAdd, 10 + iAdd)-(UserControl.ScaleWidth - 10 - iAdd, 10 + iAdd), LIGHT_MID_BORDER_COLOR
            UserControl.Line (10 + iAdd, 1 + iAdd)-(10 + iAdd, UserControl.ScaleHeight - 10 - iAdd), LIGHT_MID_BORDER_COLOR
            
            UserControl.DrawWidth = 1
            UserControl.Line (1 + iAdd, UserControl.ScaleHeight - 10 - iAdd)-(UserControl.ScaleWidth - 1 - iAdd, UserControl.ScaleHeight - 10 - iAdd), DARK_BORDER_COLOR
            UserControl.Line (UserControl.ScaleWidth - 10 - iAdd, 1 + iAdd)-(UserControl.ScaleWidth - 10 - iAdd, UserControl.ScaleHeight - 1 - iAdd), DARK_BORDER_COLOR
            
            UserControl.DrawWidth = 1
            UserControl.Line (1 + iAdd, UserControl.ScaleHeight - 30 - iAdd)-(UserControl.ScaleWidth - 10 - iAdd, UserControl.ScaleHeight - 30 - iAdd), MID_BORDER_COLOR
            UserControl.Line (UserControl.ScaleWidth - 30 - iAdd, 1 + iAdd)-(UserControl.ScaleWidth - 30 - iAdd, UserControl.ScaleHeight - 10 - iAdd), MID_BORDER_COLOR
        Else
            UserControl.DrawWidth = 1
            UserControl.Line (1, 1)-(UserControl.ScaleWidth - 10, UserControl.ScaleHeight - 10), DARK_BORDER_COLOR, B
            
            UserControl.Line (20, 20)-(UserControl.ScaleWidth - 30, UserControl.ScaleHeight - 30), MID_BORDER_COLOR, B
        End If
    End If
    
    If (bFocused = True) And (bDrawFocus = True) Then
        UserControl.DrawWidth = 1
        UserControl.DrawStyle = 1 ' Solid.

        For i = 70 To UserControl.ScaleWidth - 70 Step 30
            UserControl.PSet (i, 60), DARK_BORDER_COLOR
        Next i

        For i = 70 To UserControl.ScaleWidth - 70 Step 30
            UserControl.PSet (i, UserControl.ScaleHeight - 70), DARK_BORDER_COLOR
        Next i

        For i = 70 To UserControl.ScaleHeight - 70 Step 30
            UserControl.PSet (60, i), DARK_BORDER_COLOR
        Next i

        For i = 70 To UserControl.ScaleHeight - 70 Step 30
            UserControl.PSet (UserControl.ScaleWidth - 70, i), DARK_BORDER_COLOR
        Next i
    End If
    
    Set clsPicture = clsOldPicture
    
    UserControl.Refresh
End Sub



Private Sub tmrMouse_Timer()
Dim Pos As POINTAPI
    
    ' Enter a Time Counter Loop - Check each
    ' 10 milliseconds if the mouse is over the
    ' button. If the cursor is no longer over
    ' the button, exit the loop.
    
    ' Get the Cursor Position.
    Call GetCursorPos(Pos)
    Call ScreenToClient(UserControl.hwnd, Pos)
    Pos.X = Screen.TwipsPerPixelX * Pos.X
    Pos.Y = Screen.TwipsPerPixelY * Pos.Y
    
    If ((Pos.X >= 0) And (Pos.X <= 0 + UserControl.ScaleWidth)) And _
    ((Pos.Y >= 0) And (Pos.Y <= 0 + UserControl.ScaleHeight)) Then
        ' The mouse is over the Button.
        bMouseOver = True
        
        RedrawButton
    Else
        ' Redraw the button if it's in a mouse over mode.
        If (bMouseOver = True) Then
            bMouseOver = False
            
            RedrawButton
            
            RaiseEvent MouseOut
        Else
            ' Exit the loop because the cursor
            ' is no longer over the button.
            tmrMouse.Enabled = False
        End If
    End If
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
RaiseEvent DblClick
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

'
' UserControl Private Events.
'

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    bButtonDown = True
    
    RedrawButton
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Enter a Loop that checks (using a timer)
    ' if the mouse is over the control.
    tmrMouse.Interval = 10
    tmrMouse.Enabled = True
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (udtStyle = Standard) Then
        bButtonDown = False
    Else
        If (bChecked = False) Then
            bChecked = True
            bButtonDown = True
        Else
            bChecked = False
            bButtonDown = False
        End If
    End If
    
    RedrawButton
End Sub

Private Sub UserControl_GotFocus()
    bFocused = True
    
    RedrawButton
End Sub

Private Sub UserControl_LostFocus()
    bFocused = False
    
    RedrawButton
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
    If (Chr$(KeyCode) = " ") Then
        bFocused = True
        bButtonDown = True
        
        RedrawButton
    End If
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
    
    If (udtStyle = Standard) Then
        bButtonDown = False
    Else
        If (bChecked = False) Then
            bChecked = True
            bButtonDown = True
        Else
            bChecked = False
            bButtonDown = False
        End If
    End If
    
    RedrawButton
End Sub


Private Sub UserControl_Resize()
    RedrawButton
End Sub


'
' Properties Related Private Subs.
'


Private Sub UserControl_InitProperties()
    ' Set Initial Values.
    udtAppearance = [3D]
    udtMouseOverAppearance = [3D]
    udtButtonDownAppearance = [3D]
    
    udtStyle = Standard
    bChecked = False

    bVisible = True
    Set clsPicture = Nothing
    Set clsDownPicture = Nothing
    bDrawFocus = True
    
    UserControl.Enabled = True

    UserControl.AutoRedraw = True
    UserControl.BorderStyle = 0 ' None.
    UserControl.Backcolor = &HC0C0C0
    UserControl.ForeColor = vbBlack
    Set UserControl.Picture = LoadPicture()
    
    sCaption = UserControl.Name

    UserControl.Cls

    RedrawButton
    
    tmrMouse.Enabled = False
End Sub


Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    ' Read Properties Values.
    udtAppearance = PropBag.ReadProperty("Appearance", [3D])
    UserControl.Backcolor = PropBag.ReadProperty("Backcolor", &HC0C0C0)
    udtButtonDownAppearance = PropBag.ReadProperty("ButtonDownAppearance", [3D])
    sCaption = PropBag.ReadProperty("Caption", UserControl.Name)
    bChecked = PropBag.ReadProperty("Checked", False)
    Set clsDownPicture = PropBag.ReadProperty("DownPicture", Nothing)
    bDrawFocus = PropBag.ReadProperty("DrawFocus", True)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    
    UserControl.Font.Bold = PropBag.ReadProperty("FontBold", False)
    UserControl.Font.Charset = PropBag.ReadProperty("FontCharset", 177)
    UserControl.Font.Italic = PropBag.ReadProperty("FontItalic", False)
    UserControl.Font.Name = PropBag.ReadProperty("FontName", "MS Sans Sarif")
    UserControl.Font.Size = PropBag.ReadProperty("FontSize", 8)
    UserControl.Font.Strikethrough = PropBag.ReadProperty("FontStrikethrough", False)
    UserControl.Font.Underline = PropBag.ReadProperty("FontUnderline", False)
    UserControl.Font.Weight = PropBag.ReadProperty("FontWeight", 400)
    
    UserControl.ForeColor = PropBag.ReadProperty("Forecolor", vbBlack)
    UserControl.Height = PropBag.ReadProperty("Height", 100)
    'UserControl.Left = PropBag.ReadProperty("Left", 0)
    udtMouseOverAppearance = PropBag.ReadProperty("MouseOverAppearance", [3D])
    Set clsPicture = PropBag.ReadProperty("Picture", Nothing)
    udtStyle = PropBag.ReadProperty("Style", [Standard])
    'UserControl.Top = PropBag.ReadProperty("Top", 0)
    bVisible = PropBag.ReadProperty("Visible", True)
    UserControl.Width = PropBag.ReadProperty("Width", 100)

    RedrawButton
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    ' Set Properties Values.
    PropBag.WriteProperty "Appearance", udtAppearance, [3D]
    PropBag.WriteProperty "Backcolor", UserControl.Backcolor, &HC0C0C0
    PropBag.WriteProperty "ButtonDownAppearance", udtButtonDownAppearance, [3D]
    PropBag.WriteProperty "Caption", sCaption, UserControl.Name
    PropBag.WriteProperty "Checked", bChecked, False
    PropBag.WriteProperty "DownPicture", clsDownPicture, Nothing
    PropBag.WriteProperty "DrawFocus", bDrawFocus, True
    PropBag.WriteProperty "Enabled", UserControl.Enabled, True
    
    PropBag.WriteProperty "FontBold", UserControl.Font.Bold
    PropBag.WriteProperty "FontCharset", UserControl.Font.Charset
    PropBag.WriteProperty "FontItalic", UserControl.Font.Italic
    PropBag.WriteProperty "FontName", UserControl.Font.Name
    PropBag.WriteProperty "FontSize", UserControl.Font.Size
    PropBag.WriteProperty "FontStrikethrough", UserControl.Font.Strikethrough
    PropBag.WriteProperty "FontUnderline", UserControl.Font.Underline
    PropBag.WriteProperty "FontWeight", UserControl.Font.Weight
    
    PropBag.WriteProperty "Forecolor", UserControl.ForeColor, vbBlack
    PropBag.WriteProperty "Height", UserControl.Height, 100
    'PropBag.WriteProperty "Left", UserControl.Left, 0
    PropBag.WriteProperty "MouseOverAppearance", udtMouseOverAppearance, [3D]
    PropBag.WriteProperty "Picture", clsPicture, Nothing
    PropBag.WriteProperty "Style", udtStyle, [Standard]
    'PropBag.WriteProperty "Top", UserControl.Top, 0
    PropBag.WriteProperty "Visible", bVisible, True
    PropBag.WriteProperty "Width", UserControl.Width, 100

    RedrawButton
End Sub
