VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsSoftButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'
' Class clsSoftButton (clsSoftButton.cls)
' -----------------------------------------
'
' Purpose: Used as Class to draw and hold a soft
' button's properties.
'


'
' Private Types.
'

Private Type POINTAPI
        x As Long
        y As Long
End Type


'
' Private Constants.
'

Private Const SRCCOPY = &HCC0020


'
' Private Functions Declarations.
'


Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long


'
' Public Enums.
'

Public Enum AppearanceStyle
    [Flat]
    [Soft]
    [3D]
End Enum


'
' Private Variables.
'


' The Button's Caption.
Private sCaption As String
' Appearance of the Button (Flat, Soft or 3D).
Private udtAppearance As AppearanceStyle
' Appearance of the Button (Flat, Soft or 3D)
' when the mouse is over the button.
Private udtMouseOverAppearance As AppearanceStyle
' Appearance of the Button (Flat, Soft or 3D)
' when the button is pressed down.
Private udtButtonDownAppearance As AppearanceStyle
' Visible Property.
Private bVisible As Boolean
' The Picture Property.
Private clsPicture As StdPicture
' The Picture Box Object to be used as the Button.
Private WithEvents picPictureBox As PictureBox
Attribute picPictureBox.VB_VarHelpID = -1
' Is the Button being pressed down?
Private bButtonDown As Boolean
' Does the Button has the Focus?
Private bFocused As Boolean
' Is the Mouse Over the Button.
Private bMouseOver As Boolean


'
' Public Events.
'


Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event Click()
Public Event DblClick()

Public Event MouseOut()

Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)

Public Event GotFocus()
Public Event LostFocus()

'
' Public Properties.
'


'
' ForeColor Property.
'

Public Property Get ForeColor() As Long
    ForeColor = picPictureBox.ForeColor
End Property

Public Property Let ForeColor(ByVal vData As Long)
    picPictureBox.ForeColor = vData
End Property


'
' Font Property.
'


Public Property Get Font() As StdFont
    Set Font = picPictureBox.Font
End Property

Public Property Let Font(ByVal vData As StdFont)
    Set picPictureBox.Font = vData
End Property


'
' Picture Property.
'


Public Property Get Picture() As StdPicture
    Set Picture = mvarPicture
End Property

Public Property Let Picture(ByVal vData As StdPicture)
    Set clsPicture = vData

    RedrawButton
End Property


'
' Visible Property.
'


Public Property Get Visible() As Boolean
    Visible = picPictureBox.Visible
End Property

Public Property Let Visible(ByVal vData As Boolean)
    picPictureBox.Visible = vData
End Property


'
' Appearance Property.
'


Public Property Get Appearance() As AppearanceStyle
    Appearance = udtAppearance
End Property

Public Property Let Appearance(ByVal vData As AppearanceStyle)
    udtAppearance = vData
    
    Call RedrawButton
End Property


'
' MouseOverAppearance Property.
'


Public Property Get MouseOverAppearance() As AppearanceStyle
    MouseOverAppearance = udtMouseOverAppearance
End Property

Public Property Let MouseOverAppearance(ByVal vData As AppearanceStyle)
    udtMouseOverAppearance = vData
End Property


'
' ButtonDownAppearance Property.
'


Public Property Get ButtonDownAppearance() As AppearanceStyle
    ButtonDownAppearance = udtButtonDownAppearance
End Property

Public Property Let ButtonDownAppearance(ByVal vData As AppearanceStyle)
    udtButtonDownAppearance = vData
End Property


'
' Backcolor Property.
'


Public Property Get Backcolor() As Long
    Backcolor = picPictureBox.Backcolor
End Property

Public Property Let Backcolor(ByVal vData As Long)
    picPictureBox.Backcolor = vData
End Property


'
' Height Property.
'


Public Property Get Height() As Integer
    Height = picPictureBox.Height
End Property

Public Property Let Height(ByVal vData As Integer)
    picPictureBox.Height = vData
End Property


'
' Width Property.
'


Public Property Get Width() As Integer
    Width = picPictureBox.Width
End Property

Public Property Let Width(ByVal vData As Integer)
    picPictureBox.Width = vData
End Property


'
' Top Property.
'


Public Property Get Top() As Integer
    Top = picPictureBox.Top
End Property

Public Property Let Top(ByVal vData As Integer)
    picPictureBox.Top = vData
End Property


'
' Left Top.
'

Public Property Get Left() As Integer
    Left = picPictureBox.Left
End Property

Public Property Let Left(ByVal vData As Integer)
    picPictureBox.Left = vData
End Property


'
' Caption Property.
'


Public Property Get Caption() As String
    Caption = sCaption
End Property

Public Property Let Caption(ByVal vData As String)
    sCaption = vData
    
    RedrawButton
End Property


'
' Public Subs.
'


'
' Attaches a Picturebox to the Class.
' The picturebox will be used as the soft button.
'
Public Sub AttachButton(Button As PictureBox)
    If Not (UCase$(TypeName(Button)) = "PICTUREBOX") Then
        ' The Button is not a Picturebox.
        Exit Sub
    End If
    
    Set picPictureBox = Button
    
    ' Set initial values.
    picPictureBox.AutoRedraw = True
    picPictureBox.AutoSize = False
    'picPictureBox.Appearance = 0 ' Flat.
    picPictureBox.BorderStyle = 0 ' None.
    picPictureBox.Backcolor = &HC0C0C0
    picPictureBox.ForeColor = vbBlack
    Set picPictureBox.Picture = LoadPicture("")
    picPictureBox.Cls
End Sub


'
' Detaches the button.
'
Public Sub DetachButton()
    Set picPictureBox = Nothing
End Sub


'
' Private Subs.
'


'
' Redraws the button.
'
Private Sub RedrawButton()
Const LIGHT_BORDER_COLOR As Long = vbWhite '&HE0E0E0
Const LIGHT_MID_BORDER_COLOR As Long = &HE0E0E0
Const MID_BORDER_COLOR As Long = &H808080
Const DARK_BORDER_COLOR As Long = vbBlack

Dim i As Integer
Dim iPicWidth As Integer, iPicHeight As Integer

    ' Clear the picture box first.
    picPictureBox.Cls
    
    picPictureBox.DrawWidth = 1
    picPictureBox.DrawStyle = 0 ' Solid.
    picPictureBox.DrawMode = 13 ' Copy Pen.
    
    If (clsPicture Is Nothing) Then
        iPicWidth = 0
        iPicHeight = picPictureBox.TextHeight(sCaption)
    Else
        iPicWidth = clsPicture.Width
        
        If (sCaption <> "") Then
            iPicHeight = picPictureBox.TextHeight(sCaption) 'clsPicture.Height
        Else
            iPicHeight = clsPicture.Height
        End If
    End If
    
    If (Not (clsPicture Is Nothing)) And (sCaption = "") Then
        picPictureBox.CurrentX = (picPictureBox.Width - iPicWidth) / 2
        picPictureBox.CurrentY = (picPictureBox.Height - (iPicHeight / 2)) / 2
    ElseIf (Not (clsPicture Is Nothing)) And (sCaption <> "") Then
        picPictureBox.CurrentX = (picPictureBox.Width - (picPictureBox.TextWidth(sCaption) + iPicWidth)) / 2
        picPictureBox.CurrentY = (picPictureBox.Height - iPicHeight) / 2
    ElseIf (clsPicture Is Nothing) And (sCaption <> "") Then
        picPictureBox.CurrentX = (picPictureBox.Width - picPictureBox.TextWidth(sCaption)) / 2
        picPictureBox.CurrentY = (picPictureBox.Height - picPictureBox.TextHeight(sCaption)) / 2
    End If
    
    If Not (clsPicture Is Nothing) Then
        ' Print the Picture.
        'Call BitBlt(picPictureBox.hDC, 0, 0, clsPicture.Width, clsPicture.Height, clsPicture.Handle, 0, 0, SRCCOPY)
        Call picPictureBox.PaintPicture(clsPicture, picPictureBox.CurrentX, picPictureBox.CurrentY)
        'picPictureBox.Picture = clsPicture
        picPictureBox.CurrentX = picPictureBox.CurrentX + clsPicture.Width
    End If
    
    If (sCaption <> "") Then
        ' Draw the Caption.
        picPictureBox.Print sCaption
    End If
    
    If ((udtAppearance = Flat) And (bMouseOver = False) And (bButtonDown = False)) Or _
    ((udtMouseOverAppearance = Flat) And (bMouseOver = True) And (bButtonDown = False)) Or _
    ((udtButtonDownAppearance = Flat) And (bButtonDown = True)) Then
        ' Draw no border.
        
    ElseIf ((udtAppearance = Soft) And (bMouseOver = False) And (bButtonDown = False)) Or _
    ((udtMouseOverAppearance = Soft) And (bMouseOver = True) And (bButtonDown = False)) Or _
    ((udtButtonDownAppearance = Soft) And (bButtonDown = True)) Then
        ' Draw a Soft Border.
        
        If (bButtonDown = False) Then
            picPictureBox.Line (1, 1)-(picPictureBox.Width - 10, 1), LIGHT_BORDER_COLOR
            picPictureBox.Line (1, 1)-(1, picPictureBox.Height - 10), LIGHT_BORDER_COLOR
            
            picPictureBox.Line (1, picPictureBox.Height - 10)-(picPictureBox.Width - 7, picPictureBox.Height - 10), DARK_BORDER_COLOR
            picPictureBox.Line (picPictureBox.Width - 10, 1)-(picPictureBox.Width - 10, picPictureBox.Height - 10), DARK_BORDER_COLOR
        Else
            picPictureBox.Line (1, 1)-(picPictureBox.Width - 10, 1), DARK_BORDER_COLOR
            picPictureBox.Line (1, 1)-(1, picPictureBox.Height - 10), DARK_BORDER_COLOR
            
            picPictureBox.Line (1, picPictureBox.Height - 10)-(picPictureBox.Width - 7, picPictureBox.Height - 10), LIGHT_BORDER_COLOR
            picPictureBox.Line (picPictureBox.Width - 10, 1)-(picPictureBox.Width - 10, picPictureBox.Height - 10), LIGHT_BORDER_COLOR
        End If
    ElseIf ((udtAppearance = [3D]) And (bMouseOver = False) And (bButtonDown = False)) Or _
    ((udtMouseOverAppearance = [3D]) And (bMouseOver = True) And (bButtonDown = False)) Or _
    ((udtButtonDownAppearance = [3D]) And (bButtonDown = True)) Then
        ' Draw a 3D Border.
        
        If (bButtonDown = False) Then
            picPictureBox.DrawWidth = 2
            picPictureBox.Line (1, 1)-(picPictureBox.Width - 10, 1), LIGHT_BORDER_COLOR
            picPictureBox.Line (1, 1)-(1, picPictureBox.Height - 10), LIGHT_BORDER_COLOR
            
            picPictureBox.DrawWidth = 1
            picPictureBox.Line (1, 20)-(picPictureBox.Width - 10, 20), LIGHT_MID_BORDER_COLOR
            picPictureBox.Line (20, 1)-(20, picPictureBox.Height - 10), LIGHT_MID_BORDER_COLOR
            
            picPictureBox.DrawWidth = 2
            picPictureBox.Line (1, picPictureBox.Height - 10)-(picPictureBox.Width - 10, picPictureBox.Height - 10), DARK_BORDER_COLOR
            picPictureBox.Line (picPictureBox.Width - 10, 1)-(picPictureBox.Width - 10, picPictureBox.Height - 10), DARK_BORDER_COLOR
            
            picPictureBox.DrawWidth = 1
            picPictureBox.Line (1, picPictureBox.Height - 30)-(picPictureBox.Width - 10, picPictureBox.Height - 30), MID_BORDER_COLOR
            picPictureBox.Line (picPictureBox.Width - 30, 1)-(picPictureBox.Width - 30, picPictureBox.Height - 10), MID_BORDER_COLOR
        Else
            picPictureBox.DrawWidth = 1
            picPictureBox.Line (1, 1)-(picPictureBox.Width - 10, picPictureBox.Height - 10), DARK_BORDER_COLOR, B
            
            picPictureBox.Line (20, 20)-(picPictureBox.Width - 30, picPictureBox.Height - 30), MID_BORDER_COLOR, B
        End If
    End If
    
    If (bFocused = True) Then
        picPictureBox.DrawWidth = 1
        picPictureBox.DrawStyle = 1 ' Solid.
        
        For i = 40 To picPictureBox.Width - 70 Step 30
            picPictureBox.PSet (i, 40), DARK_BORDER_COLOR
        Next i
        
        For i = 40 To picPictureBox.Width - 70 Step 30
            picPictureBox.PSet (i, picPictureBox.Height - 70), DARK_BORDER_COLOR
        Next i
        
        For i = 40 To picPictureBox.Height - 70 Step 30
            picPictureBox.PSet (40, i), DARK_BORDER_COLOR
        Next i
        
        For i = 40 To picPictureBox.Height - 70 Step 30
            picPictureBox.PSet (picPictureBox.Width - 70, i), DARK_BORDER_COLOR
        Next i
        
        'picPictureBox.DrawWidth = 1
        'picPictureBox.DrawStyle = 2 ' Dot.
        'picPictureBox.Line (40, 40)-(picPictureBox.Width - 70, picPictureBox.Height - 70), DARK_BORDER_COLOR, B
    End If
    
    picPictureBox.Refresh
End Sub


Private Sub Class_Initialize()
    ' Set Initial Values.
    udtAppearance = [3D]
    udtMouseOverAppearance = [3D]
    udtButtonDownAppearance = [3D]
End Sub

'
' picPictureBox Private Events.
'

Private Sub picPictureBox_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    bButtonDown = True
    
    RedrawButton
    
    RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub picPictureBox_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim Pos As POINTAPI
    
    ' Enter a Time Counter Loop - Check each
    ' 500 milliseconds if the mouse is over the
    ' button.
    Do While Not (picPictureBox Is Nothing)
        ' Get the Cursor Position.
        Call GetCursorPos(Pos)
        Call ScreenToClient(picPictureBox.Parent.hwnd, Pos)
        Pos.x = Screen.TwipsPerPixelX * Pos.x
        Pos.y = Screen.TwipsPerPixelY * Pos.y
        
        If ((Pos.x >= picPictureBox.Left) And (Pos.x <= picPictureBox.Left + picPictureBox.Width)) And _
        ((Pos.y >= picPictureBox.Top) And (Pos.y <= picPictureBox.Top + picPictureBox.Height)) Then
            ' The mouse is over the Button.
            bMouseOver = True
            
            RedrawButton
            
            RaiseEvent MouseMove(Button, Shift, x, y)
        Else
            ' Redraw the button if it's in a mouse over mode.
            If (bMouseOver = True) Then
                bMouseOver = False
                
                RedrawButton
                
                RaiseEvent MouseOut
            End If
        End If
    
        DoEvents
    Loop
End Sub

Private Sub picPictureBox_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    bButtonDown = False
    
    RedrawButton
    
    RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

Private Sub picPictureBox_Click()
    RaiseEvent Click
End Sub

Private Sub picPictureBox_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub picPictureBox_GotFocus()
    bFocused = True
    
    RedrawButton
    
    RaiseEvent GotFocus
End Sub

Private Sub picPictureBox_LostFocus()
    bFocused = False
    
    RedrawButton
    
    RaiseEvent LostFocus
End Sub

Private Sub picPictureBox_KeyDown(KeyCode As Integer, Shift As Integer)
    If (Chr$(KeyCode) = " ") Then
        bFocused = True
        bButtonDown = True
        
        RedrawButton
    End If
    
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub picPictureBox_KeyUp(KeyCode As Integer, Shift As Integer)
    bButtonDown = False
    
    RedrawButton
    
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub picPictureBox_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub
